/* AUTODATE.C - Contains date and time display formatting functions.

                Display format is controlled by the parameters
                retrieved by country().
*/

#include "environ.h"

#ifdef MSDOS
#include <stdlib.h>
#include <dos.h>
#endif

struct COUNTRY  _cp;
int             _cpempty = TRUE;
int             _cpmanual = FALSE;

CHARDATE autodate(struct tm *tbp, int fmt, int code)
{
    static char *month[] =    {    "Jan", "Feb", "Mar", "Apr", 
                                   "May", "Jun", "Jul", "Aug", 
                                   "Sep", "Oct", "Nov", "Dec",
                                   "???"
                              };
    static char        date[11];
    int                century;
    
    if (fmt == MANUAL)
    {
        country(code,&_cp);
        _cpempty = TRUE;
        _cpmanual = TRUE;
    }
    else
    {
        if (_cpempty)    /* read country parameters if necessary */
        {
            country(0,&_cp);
            _cpempty = FALSE;
            _cpmanual = FALSE;
        }
    }

    tbp->tm_year = abs(tbp->tm_year)%100;
    if (tbp->tm_mon < 0 || tbp->tm_mon > 11)
        tbp->tm_mon = 12;
    tbp->tm_mday = abs(tbp->tm_mday)%100;

    if (fmt == DDMMMYY)
        sprintf(date,"%02d%03s%02d",
                tbp->tm_mday,month[(tbp->tm_mon)],tbp->tm_year);
    else
    {
        if (tbp->tm_year < 80)
            century = 2000;
        else
            century = 1900;
            
        switch (_cp.co_date)
        {
            case 0: sprintf(date,"%02d%1s%02d%1s%04d",
                            tbp->tm_mon+1,_cp.co_dtsep,
                            tbp->tm_mday,_cp.co_dtsep,
                            tbp->tm_year+century);
                    break;
            case 1: sprintf(date,"%02d%1s%02d%1s%04d",
                            tbp->tm_mday,_cp.co_dtsep,
                            tbp->tm_mon+1,_cp.co_dtsep,
                            tbp->tm_year+century);
                    break;
            default:sprintf(date,"%04d%1s%02d%1s%02d",
                            tbp->tm_year+century,_cp.co_dtsep,
                            tbp->tm_mon+1,_cp.co_dtsep,
                            tbp->tm_mday);
        }
    }
    return(date);
}

CHARTIME autotime(struct tm *tbp)
{
    int           hours,
                  mins,
                  secs,
                  pm;
    static char   *xx[] = { "am", "pm" };
    static char   time[12];

    if (!_cpmanual)
        if (_cpempty)    /* read country parameters if necessary */
        {
            country(0,&_cp);
            _cpempty = FALSE;
        }

    hours = abs(tbp->tm_hour)%100;
    mins = abs(tbp->tm_min)%100;
    secs = abs(tbp->tm_sec)%100;
    
    if (_cp.co_time == 0)
    {
        pm = (hours/12)%2;
        hours = hours%12;
        
        sprintf(time,"%d%1s%02d%1s%02d %02s",
                hours,_cp.co_tmsep,tbp->tm_min,
                _cp.co_tmsep,tbp->tm_sec,xx[pm]);
    }
    else
        sprintf(time,"%02d%1s%02d%1s%02d",
                hours,_cp.co_tmsep,tbp->tm_min,
                _cp.co_tmsep,tbp->tm_sec);
    return(time);
}
