/* GETKEY.C - gets a single keystroke from stdin. 

              This is a basic raw, unbuffered keyboard single key
              terminal read operation.
    
*/

#include <stdio.h>
#include "environ.h"

#ifdef LINUX
#include <termios.h>
#include <unistd.h>
#endif

#ifdef MSDOS
#include <io.h>
#endif

#ifdef LINUX
char getkey(void)
{
    char           c;
    struct termios modes, savemodes;
    
    fflush(stdout);
    if (tcgetattr(0, &modes) < 0)
        error(progname(),
              "getkey:",
              "tcgetattr() failed");

        savemodes = modes;
  	 modes.c_lflag &= ~ICANON;
    if (tcsetattr(0, TCSAFLUSH, &modes) < 0)
        error(progname(),
              "getkey:",
              "tcsetattr() failed");

    if (fread(&c, sizeof(char), 1, stdin) == 0)
        c = 0x1b;

    if (tcsetattr(0, TCSAFLUSH, &savemodes) < 0)
        error(progname(),
              "getkey:",
              "tcsetattr() failed restoring settings");
    return c;
}
#endif

#ifdef OS9
char getkey(void)
{
char getkey()
{
    char    c;

    fflush(stdout);
    if (read(1,&c,1) == 0)
        c = 0x1b;
    return c;
}
#endif

#ifdef MSDOS
char getkey(void)
{
    char    c;
    int     r;
    
    fflush(stdout);
    c = fgetc(stdin);
    if (c == EOF)
    {
        error(progname(), "getkey(): read() failed", "");
    }
    
    return c;
}
#endif