/* FIXEXT.C - Set the filename extension to that provided.

              The revised name is in a hidden place;
              a pointer to it is returned. Multiple calls
              should free this area when it isn't needed
              any more.
*/

#include "environ.h"

#ifdef OS9
#include <strings.h>
#endif

#ifdef MSDOS
#include <string.h>
#include <stdlib.h>
#endif

#ifdef LINUX
#include <string.h>
#endif

char* fixext(char *name, char *ext)
{
    char   *t;
    int    i;
    int    n;
    
    n = strlen(name);
    t = (char*)malloc(n+strlen(ext)+3);
    if (t == NULL)
        return (NULL);
        
    strcpy(t,name);
    for (i=n-1; i>=0; i--)
        if (t[i] == '.')
            break;

    if (strcmp(t,".") == 0 || strcmp(t,"..") == 0)
        return(t);
    if (i == 0)
        i = -1;           /* .xxxx treated as xxxx */
    if (i == -1)
        strcat(t,".");    /* no .ext found */
    else
        t[i+1] = 0;       /* remove extension */
    strcat(t,ext);        /* append new extension */
    return(t);
}
