/* GETDELCODE.C - gets the current delete code (usually ^H or DEL)
                  from the terminal control block. 

*/

#include <stdio.h>
#include "environ.h"

#ifdef LINUX
#include <termios.h>
#include <unistd.h>
#endif

#ifdef OS9
char getdelcode(void)
{
    return (0x08);
}
#endif

#ifdef LINUX
char getdelcode(void)
{
    struct termios modes;
    
    if (tcgetattr(0, &modes) < 0)
        error(progname(),
              "getdelcode():",
              "tcgetattr() failed");

    return (modes.c_cc[VERASE]);
}
#endif

#ifdef MSDOS
char getdelcode(void)
{
    return (0x08);
}
#endif
