/* DISPTIME.C - Display the current date and time    

                Release history:
                    
                1.0 -           Initial release
                1.1 - Aug 1992  copyright notice added
                1.2 - Aug 1992  autotime(), autodate() used
                1.3 - Feb 2002  ported to Linux
*/

#define VERSION       "1.3"
#define COPYRIGHT     "(c) M.C.Gregorie, 1992"

#include <environ.h>

main(int argc, char **argv)
{
    int opt;

    time_t      timer;
    struct      tm    *tbp;
    CHARDATE    datestr;
    CHARTIME    timestr;

    setprog(argv[0]);

    /*
    	Prevent confusion between "-?" and any other invalid option
    */  
    optbad = '!'; 
    while ((opt = getopt(argc,argv,"?")) != EOF)
    {
        if (opt == '?')
        {
            printf("\ndisptime v%s %s\n\n",VERSION,COPYRIGHT);
            printf("Syntax:   disptime\n");
            printf("Function: Display the current date and time\n");
            printf("Options:  none\n");
            return(0);
        }
        else
        {
            error(progname(), "Invalid option supplied", "");
        }
    }            

    /*
        Get the time & date from the system
    */
    timer = time(NULL);         /* read the clock */
    tbp = localtime(&timer);    /* split out elements */

    /* 
        Output the time
    */
    datestr = autodate(tbp,DDMMMYY, 0);
    timestr = autotime(tbp);
    printf("\n%s  %s\n",datestr,timestr);

    return(0);
}

