/* TESTPAUSE - Test harness for setpause */

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include "environ.h"

#ifdef LINUX
#include <sys/stat.h>
#include <sys/fcntl.h>
#endif

#ifdef MSDOS
#include <sys/stat.h>
#include <stdlib.h>
#include <io.h>
#endif

char *op[] = { "P_RECORD", "P_PAUSE", "P_NOPAUSE", "P_RESTORE", "bad op" };

void checkreply(int r, int a, int p)
{
    int    i;

    i = a-1;
    if (i>3 || i<0)
        i = 4;
        
    printf("Reply for operation %d (%s) on pathno %d is %d\n",
            a, op[i], p, r);
    if (r<0)
    {
        printf("Abandoned\n");
        exit(1);
    }
}

int main(int argc, char **argv)
{
    int     i, r, p;
    char    buf[80];

    setprog(argv[0]);
    
    if (argc<2)
    {
        printf("Piss OFF!\n");
        exit(1);
    }
    r = setpause(P_RECORD,1);
    checkreply(r,P_RECORD,1);

    if (strcmp(argv[1],"pause")==0)
    {
        r = setpause(P_PAUSE,1);
        checkreply(r,P_PAUSE,1);
        for (i=1; i<30; i++)
            printf("Paused line %d\n",i);
        r = setpause(P_RESTORE,1);
        checkreply(r,P_RESTORE,1);
    }
    else
    if (strcmp(argv[1],"nopause")==0)
    {
        r = setpause(P_NOPAUSE,1);
        checkreply(r,P_NOPAUSE,1);
        for (i=1; i<30; i++)
            printf("Un-paused line %d\n",i);
        r = setpause(P_RESTORE,1);
        checkreply(r,P_RESTORE,1);
    }
    else
    if (strcmp(argv[1],"bad")==0)
    {
        i = P_RESTORE*10;
        r = setpause(i,1);
        checkreply(r,i,1);
        if (r > 0)
            exit(0);
        r = setpause(P_RESTORE,1);
        checkreply(r,P_RESTORE,1);
    }
    else
    if (strcmp(argv[1],"file")==0)
    {
        p = creat("testpause.txt",(S_IRUSR|S_IWUSR));
        if (p < -1)
            error(argv[0],"can't open","testpause.txt");
        r = setpause(P_NOPAUSE,p);
        checkreply(r,P_NOPAUSE,p);
        for (i=1; i<30; i++)
        {
            sprintf(buf,"Record no %d\n",i);
            write(p,buf,strlen(buf));
        }
        r = setpause(P_RESTORE,p);
        checkreply(r,P_RESTORE,p);
        close(p);
    }
    else
        printf("Bad arg; use pause,nopause,bad,file\n");

    exit(0);
}

