/* STRMFE.C - Add an extension to a filename that does not have one */

#include <stdio.h>
#include "environ.h"

#ifdef OS9
#include <strings.h>
#define SEP '/'
#endif

#ifdef MSDOS
#include <string.h>
#define index strchr
#define rindex strrchr
#define SEP '\\'
#endif

#ifdef LINUX
#include <string.h>
#define SEP '/'
#endif

#ifndef NULL
#define    NULL    (char*)(0)
#endif

char *strmfe(char *fullname, char *name, char *ext)
{
    char*    ptr;
    char*    savptr;

    /*
        Validate inputs
    */

    if (name == NULL)
        name = "";

    if (ext == NULL)    
    	ext = "";
    	
    /*
        Copy name to output.
    */
    strcpy(fullname,name);

    /*
        Find the last SEP in the name. If none, point
        to the start of name. Skip leading '.'s, but if
        this reaches the end of the string, backtrack on
        the '.' skipping.
    */
    if (ptr = rindex(name, SEP))
        ptr++;
    else
        ptr = name;
    savptr = ptr;
    while (*ptr == '.')
        ptr++;
    if (!(*ptr))
        ptr = savptr;

    /*
        Examine the remaining portion of the name, which
        should be effectively a local name. If it has
        no extension (recognised by the presense of '.')
        append the default extension and return a pointer
        to the result.
    */
    if (index(ptr,'.') == 0)
    {
        strcat(fullname,".");
        strcat(fullname,ext);
    }
    return fullname;
}
